import numpy as np
from scipy.io.wavfile import write

from modules.file_utils import FileUtils


if __name__ == "__main__":
    test_samples = ['5471_2', '4626_2', '3262_2', '4721_2', '3748_2', '4923_2', '3246_2', '3579_2']
    datasource_json = "./data/emo_audio_relabelled_threshold_2_test_train_split_other_class/test_dataset.json"
    json_desc = FileUtils.readJSON(datasource_json)
    save_path = "./listen_samples"
    FileUtils.deleteDir(save_path)
    FileUtils.createDir(save_path)

    mmap_x = np.memmap(
        datasource_json.replace('.json', '.mmap'),
        dtype=np.float16,
        shape=tuple(json_desc['shape'])
    )
    sample_ids = json_desc['sample_ids']

    for test_id in test_samples:
        test_sample_id = sample_ids.index(test_id)

        y = mmap_x[test_sample_id]
        y = np.array(y, dtype=np.float32)
        write(f"{save_path}/{test_id}.wav", 16_000, y)
